Draft Shape2DView: Difference between revisions

From FreeCAD Documentation
No edit summary
No edit summary
Line 37: Line 37:


<!--T:5-->
<!--T:5-->
# Optionally rotate the [[3D_view|3D view]]. Unless an [[Arch_SectionPlane|Arch SectionPlane]] is selected the camera direction in the [[3D_view|3D view]] determines the projection. For example, a top view will project onto the XY plane.
# Optionally rotate the [[3D_view|3D view]]. The camera direction in the [[3D_view|3D view]] determines the projection vector. For example, a top view will project onto the XY plane. The projection vector is ignore for projections created from [[Arch_SectionPlane|Arch SectionPlanes]].
# Optionally select one or more objects.
# Optionally select one or more objects.
# There are several ways to invoke the command:
# There are several ways to invoke the command:

Revision as of 09:37, 13 June 2021

This documentation is a work in progress. Please don't mark it as translatable since it will change in the next hours and days.

Draft Shape2DView

Menu location
Modification → Shape 2D view
Workbenches
Draft, Arch, Part, TechDraw
Default shortcut
None
Introduced in version
-
See also
None

Description

The Draft Shape2DView tool produces a 2D projection from a selected 3D solid object such as those created with the Part, PartDesign, and Arch Workbenches.

The resulting projection is a Draft object and is placed in the 3D view. This object can be displayed on a TechDraw Workbench page, using the TechDraw DraftView tool. Alternatively, TechDraw has its own tools to create projected views, the TechDraw View and TechDraw ProjectionGroup tools; however, these tools are meant for preparing technical drawings, so they create the views only in the drawing page, and not in the 3D view.

Projection of solid shapes into the XY plane

Usage

  1. Optionally rotate the 3D view. The camera direction in the 3D view determines the projection vector. For example, a top view will project onto the XY plane. The projection vector is ignore for projections created from Arch SectionPlanes.
  2. Optionally select one or more objects.
  3. There are several ways to invoke the command:
    • Press the Draft Shape2DView button.
    • Select the Modification → Shape 2D view option from the menu.
  4. If you have not yet selected an object: select an object in the 3D view.
  5. The projected object is created on the XY plane.

How to produce plans and sections with different linewidths

Drawings with different linewidths for viewed and cut lines can easily be produced by using two shape2Dview objects from a same Arch SectionPlane. One of the shape2Dview objects has its projection mode set to Solid, which renders the viewed lines, and another set to Cut lines or Cut faces to render the cut lines. The two shape2Dviews are then placed at the same location, one on top of the other.

Properties

See also: Property editor.

A Draft Shape2DView object is derived from a Part Part2DObject and inherits all its properties. It also has the following additional properties:

Data

Draft

  • DataBase (Link): specifies the object to be projected.
  • DataFace Numbers (IntegerList): specifies the indices of the faces to be projected. Only works if DataProjection Mode is Individual Faces.
  • DataFuse Arch (Bool): specifies if Arch objects of the same type and material are fused or not.
  • DataHidden Lines (Bool): specifies if hidden lines are shown or not.
  • DataIn Place (Bool): only works if the selected object is an Arch SectionPlane, and DataProjection Mode is Cutlines or Cutfaces, specifies if the projection will appear co-planar with the section plane.
  • DataProjection (Vector): specifies the direction of the projection.
  • DataProjection Mode (Enumeration): specifies the projection mode. The following modes are available:
    • Solid: projects the entire selected object.
    • Individual Faces: only projects the faces in the DataFace Numbers list.
    • Cutlines: only works if the selected object is an Arch SectionPlane, projects only the edges cut by the section plane.
    • Cutfaces: only works if the selected object is an Arch SectionPlane, projects the areas cut through solids by the section plane as faces.
    • Solid faces: projects the entire selected object by cutting faces one by one. Can be used if the Solid mode gives wrong results. introduced in version 0.20
  • DataSegment Length (Float): specifies the size in millimeters of linear segments if DataTessellation is true.
  • DataTessellation (Bool): specifies if tessellation should be performed. Tessellation means that curves are replaced by sequences of line segments. This can be computationally intensive if the DataSegment Length is too short.
  • DataVisible Only (Bool): specifies if the projection should only be recomputed if it is visible.
  • DataExclusion Points (Vector list): A list of exclusion points. Any edge passing through any of those points will not be drawn. introduced in version 0.20

View

Draft

  • ViewPattern (Enumeration): not used.
  • ViewPattern Size (Float): not used.

Scripting

See also: Autogenerated API documentation and FreeCAD Scripting Basics.

To create a 2D projection use the make_shape2dview method (introduced in version 0.19) of the Draft module. This method replaces the deprecated makeShape2DView method.

shape2dview = make_shape2dview(baseobj, projectionVector=None, facenumbers=[])
  • baseobj is the object to be projected.
  • projectionVector is the projection vector. If not supplied the Z axis is used.
  • facenumbers is a list of face numbers (0-based). If supplied only these faces are considered.
  • shape2dview is returned with the created 2D projection.

Change the ProjectionMode property of the created object if required. It can be: "Solid", "Individual Faces", "Cutlines", "Cutfaces" or "Solid faces".

Example:

import FreeCAD as App
import Draft

doc = App.newDocument()

box = doc.addObject("Part::Box", "Box")
box.Length = 2300
box.Width = 500
box.Height = 1000

shape1 = Draft.make_shape2dview(box)

shape2 = Draft.make_shape2dview(box, App.Vector(1, -1, 1))

shape3 = Draft.make_shape2dview(box, App.Vector(-1, 1, 1), [0, 5])
shape3.ProjectionMode = "Individual Faces"

doc.recompute()